use kernel::prelude::*;

module! {
    type: ModuleWithParams,
    name: "test_module",
    author: "Florian RICHER <florian.richer@protonmail.com>",
    description: "Un module noyau avec paramètres déchargé.",
    license: "GPL"
	//	Syntax as below not supported yet see https://patchew.org/linux/20250218-module-params-v3-v7-0-5e1afabcac1b%40kernel.org/
	//	params: type {
	//		default: default_value,
	//		description: "Description",
	//	}
}

struct ModuleWithParams;

impl kernel::Module for ModuleWithParams {
    fn init(_module: &'static ThisModule) -> Result<Self> {
        pr_info!("Module avec paramètres chargé.\n");

        Ok(ModuleWithParams)
    }
}

impl Drop for ModuleWithParams {
    fn drop(&mut self) {
        pr_info!("Module avec paramètres.\n");
    }
}
